;MEMORY TEST from OS65D 2.0 published in OSI Small System Journal Vol1 No.3, Sept 1977
;Modified for universal use OSI400 ASCII KB, OSI C1P/SUPERBOARD, C2/C4/C8, C3 Serial systems by Mark Spankus
;relocated to $222 to survive OSI <RESET>
;occupies $0222-$03FF or so
;
; USAGE:  Commands are: T, L, C
; The low memory address available for testing is $0400 as the program occupies the space $0000-03FF
; [T]est Memory T:<start>,<end> ... Enter T04002000 to test RAM from 0400 to 1FFF
;   address will count up, foe each loop that completes successfully an X will be displayed on the screen
;   if an error is encountered, the address will be displayed with the written content and the read content
;   press <CR> to restart the program
; [L]oad Memory L:<start>,<end>=<data> ... Enter L04002000FF to fill 0400 to 1FFF with FF, a * is printed when complete
; [C]ompare Memory C:<start>,<end>=<data> ... Enter C04000500FF to check 0400-04FF for FF, a * is printed when complete


; uses zero page $FE,$FF (screen I/O)
; $F7,  $F8 $F9  & $FC, $FD and $C4 as a mirror of $D0C4

*=$0129 ;entry point for OS65A ROM Monitor 'G' command
.byte $00,$00,$00,$00,$26,>ORG,<ORG

*=$0134 ;unused on C3, code not accessed on C1/C4 
C3IN
	LDA $FC00
	LSR A
	BCC *-4
	LDA $FC01
	AND #$7F
	RTS

ORG=$0236  ;cegmon uses lower memory

*=ORG
    .EXE *  ;emit go code for loader here
L0200    
	JSR L0365	;reset $FE,FF to D000
	STA $C5
	TAY
L0204
	LDA #$20
	JSR L0357	
	BNE L0204	;fill screen D000-D400 with 0x20
	JSR C3NEWLN ;send <CR><LF> to C3 terminal
	LDA #$C4
	STA $FE     ;set screen to D0C4 (visible part)
	CLD
	LDA #$3F
	JSR L0357	; write '?' prompt
L0215
	JSR INKEY
	CMP #$43		;'C'ompare
	BEQ L0224	
	CMP #$4C		;'L'oad
	BEQ L0224
	CMP #$54		;'T'est
	BNE L0215
L0224  			
	DEC $FE
	STA $C4     ;store command as mirror of $D0C4
	JSR L0357	;overwrite prompt with character
	LDA #$3A
	JSR L0357	; write ':' to screen
	LDX #$00
L0230  
	JSR INKEY
	CMP #$0D	
	BEQ L0200   ;return? start over
	JSR LFE93  ; character to hex nibble
	BMI L0230  ; error if negative
	JSR L0338
	INX
	CPX #$04   ;@ 4th character write a ','
	BMI L0230
	BNE L024B
	LDA #$2C	;write ',' to screen
	JSR L0357
L024B  
	CPX #$08   
L024D  
    BMI L0230
	BNE L02AE
	LDA  $C4   ;on 8th character 
	AND #$3F
	CMP #$14
	BNE L02A9
	LDX #$02
L025C  
	LDA #$B7
	JSR L0338
	DEX
	BNE L025C
	LDA #$E4
	STA $FE
L0268
	JSR L0325
	LDA $FE     ;save $FE,$FF
	PHA
	LDA $FF
	PHA
	LDA #$D0    ;set scrn addr to $D0D0 
	STA $FF
	STA $FE
	TXA
	JSR L036E   ;print hi hex nibble
	TXA
	JSR L0372   ;print low hex nibble
    JSR C3BAK
	PLA
	STA $FF
	PLA
	STA $FE
L0285
	JSR L032E
	STA ($FA),Y
	JSR L0314
	BNE L0285
	JSR L0325
L0292 
	JSR L032E
	CMP ($FA),Y
	BNE L02EB
	JSR L0314
	BNE L0292
	INX
	BNE L0268
	LDA #$58   ;print X on screen
	JSR L0357
	INC $C5
	LDA $C5
	AND #$3F
	BNE SKIP
	JSR C3NEWLN
SKIP
	JMP L0268
L02A9
	LDA #$3D
	JSR L0357
L02AE  
	CPX #$0A
	BMI L024D
	LDA $C4   ;received 10th character
	AND #$3F
	CMP #$03
	BEQ L02DB
	JSR L0325
L02BE		    ;fill memory with $F7 until end pointer $FC,$FD
	LDA $F7
	STA ($FA),Y
	JSR L0314  ;increments $FA,$FB until it matches $FC,$FD
	BNE L02BE
L02C7
	LDA #$20	;write ' ' to screen
	JSR L0357
	LDA #$2A
	JSR L0357  ;write '*' to screen
L02D1    
	JSR INKEY  ;wait for keypress
	CMP #$0D
	BNE L02D1  ;no <CR>? keep waiting
	JMP L0200  ;jmp to top
L02DB          ; compare entry point
	JSR L0325
L02DE
	LDA $F7
	CMP ($FA),Y
	BNE L02EB
	JSR L0314
	BNE L02DE
	BEQ L02C7
L02EB  
	STA $F9
	LDA ($FA),Y
	STA $F8
	LDX #$04
	LDA #$CF
	STA $FE
L02F7           ;print address stored_data read_data
	LDA #$20
	JSR L0357
L02FC
	LDA $F7,X
	JSR L036E
	LDA $F7,X
	JSR L0372
	DEX
	BEQ L02D1
	CPX #$02
	BEQ L02F7
	BPL L02FC
	BMI L02F7
	BRK
	BRK
	BRK
L0314
	INC $FA
	BNE L031A
	INC $FB
L031A
	LDA $FB
	CMP $FD
	BNE L0324
	LDA $FA
	CMP $FC
L0324       
	RTS
L0325        ;move $F8,$F9 to $FA,$FB
	LDA $F8
	STA $FA
	LDA $F9
	STA $FB
	RTS
L032E       
	LDA $FA
	EOR $FB
	STA $F7
	TXA
	EOR $F7
	RTS
L0338        ;shift hex nibble into memory locations $F7->$FC,$FD ->$F8,$F9 
	PHA      ;and echo current value to screen as '0-9','A-F'
	LDY #$04
	ASL A
	ASL A
	ASL A
	ASL A     ;shift nibble up
L033F 
	ROL A	  ;shift nibble into memory locations
	ROL $F7
	ROL $FC   ;hi range
	ROL $FD
	ROL $F8   ;low range
	ROL $F9
	DEY
	BNE L033F
	PLA
L034E          ;write converted nibble text to screen
	ORA #$30
	CMP #$3A
	BMI L0357
	CLC
	ADC #$07
L0357         ;write A to current location (on screen)
	STA ($FE),Y
	JSR C3OUT ;mirror to C3 terminal
	INC $FE
	BNE L035F
	INC $FF
L035F	         
	LDA #$D4    
	CMP $FF
	BNE L036D   ;out of screen space?

L0365			;reset screen vector to start $D000	     
	LDA #$D0
	STA $FF
	LDA #$00
	STA $FE
L036D
    RTS
L036E          ;prints hi hex nibble
	LSR A
	LSR A
	LSR A
	LSR A
L0372
	AND #$0F
	BPL L034E ;always
	;??
; from original file
; .BYTE  $F5, $BD, $E7, $F3, $67, $B7, $F3, $F5, $F3, $BF, $00
; end 0380

INKEY
	LDA $FE01  ;which ROM?
	BEQ *+5
	JMP $FEED ;vector for polled KB
	JMP C3IN


C3NEWLN
	LDA #$0D
	JSR C3OUT
	LDA #$0A
    BNE C3OUT	
C3BAK	
	LDA #$08
	JSR C3OUT
C3OUT
    PHA
	LDA $FE01
	BNE *+6
	PLA
	JMP $FE0B
	PLA
	RTS
 
;inhex
LFE93
	CMP #$30
	BMI HEXERR
	CMP #$3A
	BMI HEXMSK
	CMP #$41
	BMI HEXERR
	CMP #$47
	BPL HEXERR
	SEC
	SBC #$07
HEXMSK
	AND #$0F
	RTS
HEXERR	
    LDA #$80
	RTS
 